#include "cancellaups.h"

CancellaUps::CancellaUps(QList<Ups*> & lista, QWidget *parent) :
    QDialog(parent), upsList(lista) {
  setAttribute(Qt::WA_DeleteOnClose);
  setModal(Qt::WindowModal);
  setWindowTitle(tr("Cancella UPS"));

  QGridLayout *griglia = new QGridLayout(this);
  QLabel *l;

  l = new QLabel(tr("Scegli l'UPS da cancellare") + QChar(':'), this);
  griglia->addWidget(l);

  ups = new QComboBox(this);
  griglia->addWidget(ups);
  for(int i = 0; i < upsList.size(); i++)
    ups->addItem(upsList[i]->getInfo().nome + QString(" - ") + upsList[i]->getInfo().host, upsList[i]->getInfo().codups);

  test = new QCheckBox(tr("Spunta per confermare"), this);
  griglia->addWidget(test);
  connect(test, SIGNAL(toggled(bool)), SLOT(attivaPulsante(bool)));

  l = new QLabel(tr("Attenzione: tutti i dati salvati dell'UPS verranno eliminati."), this);
  griglia->addWidget(l);

  tastok = new QPushButton(tr("Cancella"), this);
  griglia->addWidget(tastok);
  tastok->setEnabled(false);
  connect(tastok, SIGNAL(clicked()), SLOT(ok()));

  setLayout(griglia);
}

void CancellaUps::ok() {
  if(upsList.size() > 0) {
    QList<Ups*>::Iterator it(upsList.begin());
    it += ups->currentIndex();
    emit cancella(it);
  }
  close();
}

void CancellaUps::attivaPulsante(bool b) {
  tastok->setEnabled(b);
}
