#include "global.h"

global::ValoreSingolo::ValoreSingolo() {
  id = Null;
  tipo = Testo;
}

global::ValoreSingolo global::codifica(ValoriUps v) {
  ValoreSingolo ritorna;
  ritorna.id = v;
  switch(v) {
    case LOADPCT:
      ritorna.nome = LOADPCTtxt;
      ritorna.udm = PERCENTO;
      ritorna.udmTxt = CaricoUPS;
      ritorna.tipo = ValoreSingolo::Numero;
      break;
  case LINEV:
    ritorna.nome = LINEVtxt;
    ritorna.udm = VOLT;
    ritorna.udmTxt = TensioneLinea;
    ritorna.tipo = ValoreSingolo::Numero;
    break;
  case OUTPUTV:
    ritorna.nome = OUTPUTVtxt;
    ritorna.udm = VOLT;
    ritorna.udmTxt = TensioneUscita;
    ritorna.tipo = ValoreSingolo::Numero;
    break;
  case LINEFREQ:
    ritorna.nome = LINEFREQtxt;
    ritorna.udm = HERTZ;
    ritorna.udmTxt = FrequenzaLinea;
    ritorna.tipo = ValoreSingolo::Numero;
    break;
  case ITEMP:
    ritorna.nome = ITEMPtxt;
    ritorna.udm = GRADI;
    ritorna.udmTxt = TemperaturaUPS;
    ritorna.tipo = ValoreSingolo::Numero;
    break;
  case BCHARGE:
    ritorna.nome = BCHARGEtxt;
    ritorna.udm = PERCENTO;
    ritorna.udmTxt = CaricaBatteria;
    ritorna.tipo = ValoreSingolo::Numero;
    break;
  case BATTV:
    ritorna.nome = BATTVtxt;
    ritorna.udm = VOLT;
    ritorna.udmTxt = TensioneBatteria;
    ritorna.tipo = ValoreSingolo::Numero;
    break;
  case TIMELEFT:
    ritorna.nome = TIMELEFTtxt;
    ritorna.udm = MINUTI;
    ritorna.udmTxt = TempoRimasto;
    ritorna.tipo = ValoreSingolo::Numero;
    break;
  case Potenza:
    ritorna.nome = PotenzaTxt;
    ritorna.udm = WATT;
    ritorna.udmTxt = PotenzaErogata;
    ritorna.tipo = ValoreSingolo::Numero;
    break;
  case STATUS:
    ritorna.nome = STATUStxt;
    ritorna.tipo = ValoreSingolo::Booleano;
    break;
  default:
    break;
  }
  return ritorna;
}

global::ValoriUps global::decodifica(const QString & s) {
  if(s == LOADPCTtxt) return LOADPCT;
  else if(s == LINEVtxt) return LINEV;
  else if(s == OUTPUTVtxt) return OUTPUTV;
  else if(s == LINEFREQtxt) return LINEFREQ;
  else if(s == ITEMPtxt) return ITEMP;
  else if(s == BCHARGEtxt) return BCHARGE;
  else if(s == BATTVtxt) return BATTV;
  else if(s == TIMELEFTtxt) return TIMELEFT;
  else if(s == STATUStxt) return STATUS;
  else if(s == DATEtxt) return DATE;
  else if(s == MBATTCHGtxt) return MBATTCHG;
  else if(s == MINTIMELtxt) return MINTIMEL;
  else if(s == LOTRANStxt) return LOTRANS;
  else if(s == HITRANStxt) return HITRANS;
  else if(s == NOMOUTVtxt) return NOMOUTV;
  else if(s == NOMINVtxt) return NOMINV;
  else if(s == NOMBATTVtxt) return NOMBATTV;
  else if(s == NOMPOWERtxt) return NOMPOWER;
  else if(s == HOSTNAMEtxt) return HOSTNAME;
  else if(s == RELEASEtxt) return RELEASE;
  else if(s == UPSNAMEtxt) return UPSNAME;
  else if(s == CABLEtxt) return CABLE;
  else if(s == MODELtxt) return MODEL;
  else if(s == SENSEtxt) return SENSE;
  else if(s == STATFLAGtxt) return STATFLAG;
  else if(s == SERIALNOtxt) return SERIALNO;
  else if(s == BATTDATEtxt) return BATTDATE;
  else if(s == FIRMWAREtxt) return FIRMWARE;
  else if(s == PotenzaTxt) return Potenza;
  else return Null;
}

const QString global::LOADPCTtxt("LOADPCT");
const QString global::LINEVtxt("LINEV");
const QString global::OUTPUTVtxt("OUTPUTV");
const QString global::LINEFREQtxt("LINEFREQ");
const QString global::ITEMPtxt("ITEMP");
const QString global::BCHARGEtxt("BCHARGE");
const QString global::BATTVtxt("BATTV");
const QString global::TIMELEFTtxt("TIMELEFT");
const QString global::STATUStxt("STATUS");
const QString global::DATEtxt("DATE");
const QString global::MBATTCHGtxt("MBATTCHG");
const QString global::MINTIMELtxt("MINTIMEL");
const QString global::LOTRANStxt("LOTRANS");
const QString global::HITRANStxt("HITRANS");
const QString global::NOMOUTVtxt("NOMOUTV");
const QString global::NOMINVtxt("NOMINV");
const QString global::NOMBATTVtxt("NOMBATTV");
const QString global::NOMPOWERtxt("NOMPOWER");
const QString global::HOSTNAMEtxt("HOSTNAME");
const QString global::RELEASEtxt("RELEASE");
const QString global::UPSNAMEtxt("UPSNAME");
const QString global::CABLEtxt("CABLE");
const QString global::MODELtxt("MODEL");
const QString global::SENSEtxt("SENSE");
const QString global::STATFLAGtxt("STATFLAG");
const QString global::SERIALNOtxt("SERIALNO");
const QString global::BATTDATEtxt("BATTDATE");
const QString global::FIRMWAREtxt("FIRMWARE");
const QString global::PotenzaTxt("Potenza");

const QColor global::ROSSO(255, 100, 100);
const QColor global::GIALLO(255, 255, 100);
const QColor global::VERDE(100, 255, 100);
const QColor global::GRIGIO(100, 100, 100);
const QColor global::MARRONE(170, 80, 0);
const QColor global::ARANCIO(255, 153, 0);
const QColor global::BLU(100, 100, 255);
const QColor global::DARKGREEN(50, 150, 50);
const QColor global::DARKRED(150, 50, 50);

const QString global::VOLT(QObject::tr("Volt"));
const QString global::AMPERE(QObject::tr("Ampere"));
const QString global::WATT(QObject::tr("Watt"));
const QString global::PERCENTO(QObject::tr("%"));
const QString global::MINUTI(QObject::tr("Minuti"));
const QString global::GRADI(QObject::tr("Gradi Celsius"));
const QString global::HERTZ(QObject::tr("Hertz"));

const QString global::CaricoUPS(QObject::tr("Carico dell'UPS"));
const QString global::TensioneLinea(QObject::tr("Tensione di linea"));
const QString global::TensioneUscita(QObject::tr("Tensione in uscita dall'UPS"));
const QString global::FrequenzaLinea(QObject::tr("Frequenza di linea"));
const QString global::TemperaturaUPS(QObject::tr("Temperatura dell'UPS"));
const QString global::CaricaBatteria(QObject::tr("Carica della batteria"));
const QString global::TensioneBatteria(QObject::tr("Tensione della batteria"));
const QString global::TempoRimasto(QObject::tr("Tempo rimasto"));
const QString global::PotenzaErogata(QObject::tr("Potenza erogata"));

