#ifndef GLOBAL_H
#define GLOBAL_H

#include <QtGui>
#include <QtCore>

namespace global {
    enum ValoriUps {LOADPCT, LINEV, OUTPUTV, LINEFREQ, ITEMP, BCHARGE, BATTV, TIMELEFT,
                    STATUS, DATE, MBATTCHG, MINTIMEL, LOTRANS, HITRANS, NOMOUTV, NOMINV,
                    NOMBATTV, NOMPOWER, HOSTNAME, RELEASE, UPSNAME, CABLE, MODEL, SENSE,
                    STATFLAG, SERIALNO, BATTDATE, FIRMWARE, Potenza, Null};

    struct ValoreSingolo {
      enum TipoDato {Numero, Testo, Data, Booleano};
      ValoreSingolo();
      ValoriUps id;
      QString nome;
      QString udm;
      QString udmTxt;
      TipoDato tipo;
    };

    ValoreSingolo codifica(ValoriUps v);
    ValoriUps decodifica(const QString & s);

    extern const QColor ROSSO, GIALLO, VERDE, BLU, ARANCIO, GRIGIO, MARRONE, DARKGREEN, DARKRED;
    extern const QString VOLT, AMPERE, WATT, PERCENTO, MINUTI, GRADI, HERTZ;
    extern const QString CaricoUPS, TensioneLinea, TensioneUscita, FrequenzaLinea,
                         TemperaturaUPS, CaricaBatteria, TensioneBatteria,
                         TempoRimasto, PotenzaErogata;
    extern const QString LOADPCTtxt, LINEVtxt, OUTPUTVtxt, LINEFREQtxt, ITEMPtxt, BCHARGEtxt,
                         BATTVtxt, TIMELEFTtxt, STATUStxt, DATEtxt, MBATTCHGtxt, MINTIMELtxt,
                         LOTRANStxt, HITRANStxt, NOMOUTVtxt, NOMINVtxt, NOMBATTVtxt, NOMPOWERtxt,
                         HOSTNAMEtxt, RELEASEtxt, UPSNAMEtxt, CABLEtxt, MODELtxt, SENSEtxt,
                         STATFLAGtxt, SERIALNOtxt, BATTDATEtxt, FIRMWAREtxt, PotenzaTxt;
};

#endif // GLOBAL_H
