#include "guiupsinfo.h"

GuiUpsInfo::GuiUpsInfo(QWidget *parent) :
    QWidget(parent) {
  QLabel *l;
  QPushButton *pb;

  QGridLayout *griglia = new QGridLayout(this);

  l = new QLabel(tr("Nome dell'UPS"), this);
  griglia->addWidget(l);

  nome = new QLineEdit(this);
  nome->setText(QString("UPS"));
  griglia->addWidget(nome);

  l = new QLabel(tr("Inserisci un indirizzo IP o URL valido"), this);
  griglia->addWidget(l);

  indirizzo = new QLineEdit(this);
  indirizzo->setText(QString("localhost"));
  griglia->addWidget(indirizzo);

  pb = new QPushButton(tr("Controlla la correttezza dell'indirizzo"), this);
  griglia->addWidget(pb);
  connect(pb, SIGNAL(clicked()), SLOT(calcolaIP()));

  l = new QLabel(tr("Informazioni associate:"), this);
  griglia->addWidget(l);

  lista = new QListWidget(this);
  griglia->addWidget(lista);

  l = new QLabel(tr("Inserisci una porta valida"), this);
  griglia->addWidget(l);

  porta = new QLineEdit(this);
  porta->setInputMask(QString("90000"));
  porta->setText(QString::number(3551));
  griglia->addWidget(porta);
  connect(porta, SIGNAL(editingFinished()), SLOT(validaPorta()));

  ok = new QPushButton(tr("OK"), this);
  griglia->addWidget(ok);
}

GuiUpsInfo::~GuiUpsInfo() {
}

void GuiUpsInfo::calcolaIP() {
  valori = QHostInfo::fromName(indirizzo->text());
  QList<QHostAddress> r = valori.addresses();
  if(r.size() != 0) {
    lista->clear();
    lista->addItem(QString("Host name: ") + valori.hostName());
    for(int i = 0; i < r.size(); i++)
      lista->addItem(QString("IP: ") + r[i].toString());
  }
}

void GuiUpsInfo::validaPorta() {
  int v = porta->text().toInt();
  if(v < 0 || v > 65535)
    porta->setText(QString::number(3551));
}


