#include "intervallo.h"

Intervallo::Intervallo(QColor c, double l, double h, int liv) :
    colore(c), sfumatura(true), livello(liv) {
  if(l < h) {
    sotto = l;
    sopra = h;
  } else {
    sotto = h;
    sopra = l;
  }
}

void Intervallo::setSfumatura(bool val) {
  sfumatura = val;
}

void Intervallo::setLivello(int val) {
  livello = val;
}

bool Intervallo::operator<(const Intervallo & i) const {
  if(livello == i.livello)
    return sotto < i.sotto;
  else
    return livello < i.livello;
}

QColor Intervallo::getColore() const { return colore; }
double Intervallo::getSotto() const { return sotto; }
double Intervallo::getSopra() const { return sopra; }
bool Intervallo::getSfumatura() const { return sfumatura; }
int Intervallo::getLivello() const { return livello; }

