#include "listabarre.h"

ListaBarre::ListaBarre(int ups, QSqlDatabase *db, QWidget *parent)
      : ListaWidgetAdIntervalli(ups, db, parent) {
  QWidget *w = new QWidget(this);
  QGridLayout *griglia = new QGridLayout(w);

  setMinimumSize(400, 400);

  Barra *b;

  b = new Barra(new WidgetBarra(w), global::LOADPCT, codups, db);
  griglia->addWidget(b->widget);
  barre.push_back(b);

  b = new Barra(new WidgetBarra(w), global::LINEV, codups, db);
  griglia->addWidget(b->widget);
  barre.push_back(b);

  b = new Barra(new WidgetBarra(w), global::OUTPUTV, codups, db);
  griglia->addWidget(b->widget);
  barre.push_back(b);

  b = new Barra(new WidgetBarra(w), global::LINEFREQ, codups, db);
  griglia->addWidget(b->widget);
  barre.push_back(b);

  b = new Barra(new WidgetBarra(w), global::ITEMP, codups, db);
  griglia->addWidget(b->widget);
  barre.push_back(b);

  b = new Barra(new WidgetBarra(w), global::BCHARGE, codups, db);
  griglia->addWidget(b->widget);
  barre.push_back(b);

  b = new Barra(new WidgetBarra(w), global::BATTV, codups, db);
  griglia->addWidget(b->widget);
  barre.push_back(b);

  b = new Barra(new WidgetBarra(w), global::TIMELEFT, codups, db);
  griglia->addWidget(b->widget);
  barre.push_back(b);

  b = new Barra(new WidgetBarra(w), global::Potenza, codups, db);
  griglia->addWidget(b->widget);
  barre.push_back(b);

  w->setLayout(griglia);
  setWidget(w);
}

void ListaBarre::aggiorna(const SQL::ValoriInfo & v) {
  Barra *w;
  w = trova(global::LOADPCT);
  if(w)
    dynamic_cast<WidgetBarra*>(w->widget)->pushValore(v.LOADPCT);
  w = trova(global::LINEV);
  if(w)
    dynamic_cast<WidgetBarra*>(w->widget)->pushValore(v.LINEV);
  w = trova(global::OUTPUTV);
  if(w)
    dynamic_cast<WidgetBarra*>(w->widget)->pushValore(v.OUTPUTV);
  w = trova(global::LINEFREQ);
  if(w)
    dynamic_cast<WidgetBarra*>(w->widget)->pushValore(v.LINEFREQ);
  w = trova(global::ITEMP);
  if(w)
    dynamic_cast<WidgetBarra*>(w->widget)->pushValore(v.ITEMP);
  w = trova(global::BCHARGE);
  if(w)
    dynamic_cast<WidgetBarra*>(w->widget)->pushValore(v.BCHARGE);
  w = trova(global::BATTV);
  if(w)
    dynamic_cast<WidgetBarra*>(w->widget)->pushValore(v.BATTV);
  w = trova(global::TIMELEFT);
  if(w)
    dynamic_cast<WidgetBarra*>(w->widget)->pushValore(v.TIMELEFT);
  w = trova(global::Potenza);
  if(w)
    dynamic_cast<WidgetBarra*>(w->widget)->pushValore(costanti.NOMPOWER * v.LOADPCT / 100);
}

void ListaBarre::setNumeroBarre(int b) {
  for(int i = 0; i < barre.size(); i++)
    dynamic_cast<WidgetBarra*>(barre[i]->widget)->setNumeroBarre(b);
}
