#include "listagrafici.h"

ListaGrafici::ListaGrafici(int ups, QSqlDatabase *db, QWidget *parent)
  : ListaWidgetAdIntervalli(ups, db, parent) {
  QWidget *w = new QWidget(this);
  QGridLayout *griglia = new QGridLayout(w);

  setMinimumSize(400, 400);

  Barra *b;

  b = new Barra(new WidgetGrafico(w), global::LOADPCT, codups, db);
  griglia->addWidget(b->widget);
  barre.push_back(b);

  b = new Barra(new WidgetGrafico(w), global::LINEV, codups, db);
  griglia->addWidget(b->widget);
  barre.push_back(b);

  b = new Barra(new WidgetGrafico(w), global::OUTPUTV, codups, db);
  griglia->addWidget(b->widget);
  barre.push_back(b);

  b = new Barra(new WidgetGrafico(w), global::LINEFREQ, codups, db);
  griglia->addWidget(b->widget);
  barre.push_back(b);

  b = new Barra(new WidgetGrafico(w), global::ITEMP, codups, db);
  griglia->addWidget(b->widget);
  barre.push_back(b);

  b = new Barra(new WidgetGrafico(w), global::BCHARGE, codups, db);
  griglia->addWidget(b->widget);
  barre.push_back(b);

  b = new Barra(new WidgetGrafico(w), global::BATTV, codups, db);
  griglia->addWidget(b->widget);
  barre.push_back(b);

  b = new Barra(new WidgetGrafico(w), global::TIMELEFT, codups, db);
  griglia->addWidget(b->widget);
  barre.push_back(b);

  b = new Barra(new WidgetGrafico(w), global::Potenza, codups, db);
  griglia->addWidget(b->widget);
  barre.push_back(b);

  w->setLayout(griglia);
  setWidget(w);
}

void ListaGrafici::setMaxValori(int v) {
  maxvalori = v;
}

void ListaGrafici::aggiorna(const SQL::ValoriInfo &v) {
  Barra *w;
  w = trova(global::LOADPCT);
  if(w)
    dynamic_cast<WidgetGrafico*>(w->widget)->pushValore(v.LOADPCT, v.DATE);
  w = trova(global::LINEV);
  if(w)
    dynamic_cast<WidgetGrafico*>(w->widget)->pushValore(v.LINEV, v.DATE);
  w = trova(global::OUTPUTV);
  if(w)
    dynamic_cast<WidgetGrafico*>(w->widget)->pushValore(v.OUTPUTV, v.DATE);
  w = trova(global::LINEFREQ);
  if(w)
    dynamic_cast<WidgetGrafico*>(w->widget)->pushValore(v.LINEFREQ, v.DATE);
  w = trova(global::ITEMP);
  if(w)
    dynamic_cast<WidgetGrafico*>(w->widget)->pushValore(v.ITEMP, v.DATE);
  w = trova(global::BCHARGE);
  if(w)
    dynamic_cast<WidgetGrafico*>(w->widget)->pushValore(v.BCHARGE, v.DATE);
  w = trova(global::BATTV);
  if(w)
    dynamic_cast<WidgetGrafico*>(w->widget)->pushValore(v.BATTV, v.DATE);
  w = trova(global::TIMELEFT);
  if(w)
    dynamic_cast<WidgetGrafico*>(w->widget)->pushValore(v.TIMELEFT, v.DATE);
  w = trova(global::Potenza);
  if(w)
    dynamic_cast<WidgetGrafico*>(w->widget)->pushValore(costanti.NOMPOWER * v.LOADPCT / 100, v.DATE);
}
