#include "listawidgetadintervalli.h"

ListaWidgetAdIntervalli::ListaWidgetAdIntervalli(int ups, QSqlDatabase *db, QWidget *parent)
  : QScrollArea(parent) {
  codups = ups;
  database = db;
  setWidgetResizable(true);
}

 ListaWidgetAdIntervalli::Barra::Barra(WidgetAdIntervalli *w, global::ValoriUps v, int ups, QSqlDatabase *database) {
  widget = w;
  db = database;
  codups = ups;
  valore = global::codifica(v);
  info = SQL::prendiWidget(codups, valore.nome, *db);
  widget->setVisible(info.visibile);
  widget->setTesto(valore.udmTxt, valore.udm);
  widget->setColoreValori(info.colore);
  widget->aggiungiIntervalli(SQL::prendiIntervalli(info.codwidget, *db));
}

void ListaWidgetAdIntervalli::aggiornaCostanti(const SQL::ValoriCostantiInfo & c) {
  costanti = c;
}

ListaWidgetAdIntervalli::Barra * ListaWidgetAdIntervalli::trova(global::ValoriUps v) {
  Barra *ritorna = 0;
  for(int i = 0 ; i < barre.size(); i++)
    if(barre[i]->valore.id == v)
      return barre[i];
  return ritorna;
}

void ListaWidgetAdIntervalli::setSfumatura(bool val) {
  for(int i = 0; i < barre.size(); i++)
    barre[i]->widget->setSfumatura(val);
  sfumatura = val;
}

void ListaWidgetAdIntervalli::setSfumaturaIntervalli(bool val) {
  for(int i = 0; i < barre.size(); i++)
    barre[i]->widget->setSfumaturaIntervalli(val);
  sfumatureIntervalli = val;
}

bool ListaWidgetAdIntervalli::getSfumatura() const {
  return sfumatura;
}

bool ListaWidgetAdIntervalli::getSfumaturaIntervalli() const {
  return sfumatureIntervalli;
}

WidgetAdIntervalli * ListaWidgetAdIntervalli::getWidget(global::ValoriUps v) {
  Barra *b = trova(v);
  if(b)
    return b->widget;
  else
    return 0;
}

bool ListaWidgetAdIntervalli::getVisibile(global::ValoriUps v) {
  Barra *b = trova(v);
  if(b)
    return b->info.visibile;
  else
    return false;
}

void ListaWidgetAdIntervalli::setVisible(bool visible, global::ValoriUps v) {
  Barra *b = trova(v);
  if(b) {
    b->widget->setVisible(visible);
    b->info.visibile = visible;
  }
}

void ListaWidgetAdIntervalli::salvaWidget(global::ValoriUps v) {
  Barra *b = trova(v);
  if(b) {
    SQL::cancellaWidget(b->info.codwidget, *(b->db));
    b->info.codwidget = SQL::salvaWidget(b->codups, b->valore.nome, b->info.visibile, b->widget->getColoreValori(), *(b->db));
    SQL::salvaIntervalli(b->widget->getIntervalli(), b->info.codwidget, *(b->db));
  }
}
