#ifndef LISTAWIDGETADINTERVALLI_H
#define LISTAWIDGETADINTERVALLI_H

#include <QtGui>
#include <QtCore>
#include <QtSql>
#include "widgetadintervalli.h"
#include "global.h"
#include "sql.h"

class ListaWidgetAdIntervalli : public QScrollArea {
   Q_OBJECT
   public:
      ListaWidgetAdIntervalli(int ups, QSqlDatabase *db, QWidget *parent = 0);
      bool getSfumatura() const;
      bool getSfumaturaIntervalli() const;
      WidgetAdIntervalli * getWidget(global::ValoriUps v);
      bool getVisibile(global::ValoriUps v);
      void setVisible(bool visible, global::ValoriUps v);
      void salvaWidget(global::ValoriUps v);

   protected:
      struct Barra {
        Barra(WidgetAdIntervalli *w, global::ValoriUps v, int ups, QSqlDatabase *database);
        WidgetAdIntervalli *widget;
        global::ValoreSingolo valore;
        SQL::WidgetInfo info;
        QSqlDatabase *db;
        int codups;
      };

      QVector<Barra*> barre;
      SQL::ValoriCostantiInfo costanti;
      int codups;
      QSqlDatabase *database;
      Barra* trova(global::ValoriUps v);

      bool sfumatura;
      bool sfumatureIntervalli;

   public slots:
      void aggiornaCostanti(const SQL::ValoriCostantiInfo & c);
      void setSfumatura(bool val);
      void setSfumaturaIntervalli(bool val);
      virtual void aggiorna(const SQL::ValoriInfo &v) = 0;
};

#endif // LISTAWIDGETADINTERVALLI_H
