#ifndef MAINWIDOW_H
#define MAINWIDOW_H

#include <QtCore>
#include <QtGui>
#include <QtNetwork>
#include <QtSql>
#include "listabarre.h"
#include "global.h"
#include "networkthread.h"
#include "allinfo.h"
#include "listagrafici.h"
#include "riassunto.h"
#include "ups.h"
#include "miniups.h"
#include "sql.h"
#include "intervallo.h"
#include "storico.h"
#include "parametri.h"
#include "modificaintervalliups.h"
#include "cancellaups.h"
#include "allevents.h"
#include "guiupsinfo.h"
#include "nuovo.h"
#include "modifica.h"

class MainWidow : public QMainWindow {
  Q_OBJECT

  public:
    MainWidow(QWidget *parent = 0, Qt::WindowFlags flags = 0);
    ~MainWidow();

  private:

    QList<Ups*> upsList;
    QTabWidget *tablistaUPS;
    Riassunto *riassunto;
    QSqlDatabase db;
    Storico *storico;

    void crea_gui_ups(Ups & u);
    void genera_intervalli_standard(int codups);

    int numerobarre;
    bool sfumatura;
    bool sfumaturaIntervalli;
    int giornidasalvare;

    static const QString numeroBarreTxt;
    static const QString sfumaturaTxt;
    static const QString sfumaturaIntervalliTxt;
    static const QString giornidasalvareTxt;

  private slots:
    void menu_nuovo();
    void menu_modifica();
    void menu_parametri();
    void menu_modifica_intervalli();
    void menu_cancella_ups();
    void menu_esci();
    void cancella_ups(QList<Ups*>::Iterator it);
    void nuovo_numero_barre(int n);
    void nuova_sfumatura_intervalli(bool v);
    void nuova_sfumatura_barre(bool v);
    void nuovi_giorni_da_salvare(int g);
    void update_name(QList<Ups*>::Iterator it);

  private slots:
    void nuovo_ups(const QString & i, unsigned int porta, const QString & nome);
};

#endif // MAINWIDOW_H
