#include "minicerchio.h"

MiniCerchio::MiniCerchio(QWidget *parent) :
    QWidget(parent) {
  colore = Qt::white;
  setMinimumSize(50, 50);
}

void MiniCerchio::setColore(const QColor & c) {
  colore = c;
  update();
}

void MiniCerchio::paintEvent(QPaintEvent *event) {
  event->ignore();
  QPainter paint;
  paint.begin(this);
  paint.setRenderHint(QPainter::Antialiasing, true);
  int minimo = width() > height() ? height() : width();
  minimo -= 2;
  QRectF areaEllisse(1, 1, minimo, minimo);
  areaEllisse.moveCenter(QPointF(qRound(width() / 2.0), qRound(height() / 2.0)));

  QPen penna(colore);
  penna.setWidth(2);
  paint.setPen(penna);
  QRadialGradient gradiente(areaEllisse.center(), qRound(minimo / 2.0));
  gradiente.setColorAt(0, colore);
  QColor trasparente = colore;
  trasparente.setAlpha(0);
  gradiente.setColorAt(1, trasparente);
  paint.setBrush(QBrush(gradiente));
  paint.drawEllipse(areaEllisse);

  paint.end();
}

