#include "miniups.h"

MiniUps::MiniUps(QWidget *parent) :
    QWidget(parent) {
  QGridLayout *griglia = new QGridLayout(this);

  nomeups = new QLabel(this);
  griglia->addWidget(nomeups, 0, 0, 1, 2);

  BCHARGE = new QLabel(this);
  griglia->addWidget(BCHARGE, 1, 0, 1, 1);

  TIMELEFT = new QLabel(this);
  griglia->addWidget(TIMELEFT, 2, 0, 1, 1);

  STATUS = new QLabel(this);
  griglia->addWidget(STATUS, 3, 0, 1, 1);

  cerchio = new MiniCerchio(this);
  griglia->addWidget(cerchio, 1, 1, 3, 1, Qt::AlignRight | Qt::AlignTop);

  setLayout(griglia);
  setMaximumSize(300, 100);
}

void MiniUps::aggiornaTXT(const SQL::ValoriInfo & v) {
  BCHARGE->setText(global::CaricaBatteria + QString(": ") + QString::number(v.BCHARGE) + QChar(' ') + global::PERCENTO);
  TIMELEFT->setText(global::TempoRimasto + QString(": ") + QString::number(v.TIMELEFT) + QChar(' ') + global::MINUTI);
  STATUS->setText(v.STATUS ? tr("Online") : tr("Offline"));
  if(v.LOADPCT >= 80)
    cerchio->setColore(global::ROSSO);
  else if(v.STATUS)
    cerchio->setColore(global::DARKGREEN);
  else if(v.BCHARGE <= 20)
    cerchio->setColore(global::ROSSO);
  else
    cerchio->setColore(global::ARANCIO);
}

void MiniUps::setNome(const QString & s) {
  nomeups->setText(s);
  update();
}

