#include "modifica.h"

Modifica::Modifica(QList<Ups*> & list, QWidget *parent) :
    QDialog(parent), upsList(list) {
  setAttribute(Qt::WA_DeleteOnClose);
  setModal(Qt::WindowModal);
  setWindowTitle(tr("Modifica UPS"));

  QGridLayout *griglia = new QGridLayout(this);
  QLabel *l;

  l = new QLabel(tr("Ups da modificare") + QChar(':'), this);
  griglia->addWidget(l);

  ups = new QComboBox(this);
  for(int i = 0; i < upsList.size(); i++)
    ups->addItem(upsList[i]->getInfo().nome + QString(" - ") + upsList[i]->getInfo().host, upsList[i]->getInfo().codups);
  griglia->addWidget(ups);
  connect(ups, SIGNAL(currentIndexChanged(int)), SLOT(aggiorna(int)));

  gui = new GuiUpsInfo(this);
  griglia->addWidget(gui);
  connect(gui->ok, SIGNAL(clicked()), SLOT(tastoOK()));

  aggiorna(ups->currentIndex());

  setLayout(griglia);
}

void Modifica::tastoOK() {
  int i = ups->currentIndex();
  if(i >= 0 && gui->nome->text().size() > 0) {
    QList<Ups*>::Iterator it = upsList.begin();
    it += i;
    SQL::UpsInfo info = (*it)->getInfo();
    info.nome = gui->nome->text();
    info.host = gui->indirizzo->text();
    info.porta = gui->porta->text().toInt();
    (*it)->setInfo(info);
    emit updated(it);
  }
}

void Modifica::aggiorna(int i) {
  if(i >= 0) {
    QList<Ups*>::Iterator it = upsList.begin();
    it += i;
    gui->nome->setText((*it)->getInfo().nome);
    gui->indirizzo->setText((*it)->getInfo().host);
    gui->porta->setText(QString::number((*it)->getInfo().porta));
  }
}
