#ifndef MODIFICAINTERVALLIUPS_H
#define MODIFICAINTERVALLIUPS_H

#include <QtCore>
#include <QtGui>
#include <QtSql>
#include "ups.h"
#include "listawidgetadintervalli.h"
#include "widgetbarra.h"
#include "intervallo.h"
#include "global.h"
#include "prendicolore.h"
#include "quadrattino.h"

class ModificaIntervalliUPS : public QDialog {
    Q_OBJECT
  public:
    ModificaIntervalliUPS(QList<Ups*> & lista, QSqlDatabase *d, QWidget *parent = 0);
    void setParametriGlobali(bool s, bool si, int n);

  private:
    QList<Ups*> &upsList;
    QSqlDatabase *db;

    QComboBox *ups;
    QComboBox *valoriups;
    QCheckBox *visibile;
    QTableWidget *tabellaintervallini;
    QLineEdit *valoreminimo, *valoremassimo, *livello;
    bool v_min, v_max, v_al;
    PrendiColore *colore;
    QPushButton *aggiungi, *rimuovi;
    PrendiColore *colorebarra;
    WidgetBarra *anteprima;
    QPushButton *salva, *annulla;

    bool sfumatura, sfumaturaIntervalli;
    int numerobarre;

    QTimer generatore;

    static const QString altezzaTxt, lim_sxTxt, lim_dxTxt, coloreTxt;

    void aggiorna_tabella();

  private slots:
    void genera_casuali();
    void cambia_valore_ups(int i);
    void cambia_ups();
    void annulla_modifiche();
    void testa_massimo(const QString & s);
    void testa_minimo(const QString & s);
    void testa_altezza(const QString & s);
    void cancella_intervallo();
    void cambia_colore_barre(const QColor & c);
    void aggiungi_intervallo();
    void salva_modifiche();

  public slots:

};

#endif // MODIFICAINTERVALLIUPS_H
