#include "parametri.h"

Parametri::Parametri(int b, bool s, bool si, int g, QWidget *parent) :
    QDialog(parent) {
  setAttribute(Qt::WA_DeleteOnClose);
  setModal(Qt::WindowModal);
  setWindowTitle(tr("Impostazioni del programma"));

  QGridLayout *griglia = new QGridLayout(this);
  QLabel *l;

  sfumatura = new QCheckBox(tr("Sfumatura delle barre"), this);
  griglia->addWidget(sfumatura, 0, 0, 1, 3);
  sfumatura->setChecked(s);

  sfumaturaIntervalli = new QCheckBox(tr("Sfumatura degli intervalli"), this);
  griglia->addWidget(sfumaturaIntervalli, 1, 0, 1, 3);
  sfumaturaIntervalli->setChecked(si);

  l = new QLabel(tr("Numero barre orizzontali"), this);
  griglia->addWidget(l, 2, 0, 1, 1);
  barre = new QSlider(Qt::Horizontal, this);
  griglia->addWidget(barre, 2, 1, 1, 1);
  barre->setRange(1, 19);
  barre->setValue(b);
  mostrabarre = new QLabel(QString::number(b), this);
  griglia->addWidget(mostrabarre, 2, 2, 1, 1);
  connect(barre, SIGNAL(sliderMoved(int)), SLOT(aggiorna_n_barre(int)));

  l = new QLabel(QString("<span>") + tr("Cancella valori nel db pi&ugrave; vecchi di") + QString(":</span>"), this);
  griglia->addWidget(l, 3, 0, 1, 1);
  giorni = new QLineEdit(this);
  giorni->setText(QString::number(g));
  griglia->addWidget(giorni, 3, 1, 1, 1);
  connect(giorni, SIGNAL(textChanged(QString)), SLOT(testa_numero(QString)));
  l = new QLabel(tr("giorni"), this);
  griglia->addWidget(l, 3, 2, 1, 1);

  tasto_ok = new QPushButton(tr("Ok"), this);
  griglia->addWidget(tasto_ok, 4, 0, 1, 3);
  connect(tasto_ok, SIGNAL(clicked()), SLOT(ok()));

  setLayout(griglia);
}

void Parametri::ok() {
  emit nuovo_numero_barre(barre->value());
  emit nuova_sfumatura_barre(sfumatura->isChecked());
  emit nuova_sfumatura_intervalli(sfumaturaIntervalli->isChecked());
  emit nuovi_giorni_da_salvare(giorni->text().toInt());
  close();
}

void Parametri::testa_numero(const QString & s) {
  bool b;
  int val = s.toInt(&b);
  tasto_ok->setEnabled(b && val >= 0 && val <= 1000);
}

void Parametri::aggiorna_n_barre(int v) {
  mostrabarre->setText(QString::number(v));
}
