#include "prendicolore.h"

PrendiColore::PrendiColore(QWidget *parent) :
    QWidget(parent) {
  colore = Qt::black;
  QGridLayout *griglia = new QGridLayout(this);
  QLabel *l;
  QPushButton *pb;
  Quadrattino *q;

  pb = new QPushButton(tr("Altri colori ..."), this);
  griglia->addWidget(pb, 1, 1, 1, 6);
  connect(pb, SIGNAL(clicked()), SLOT(prendi_colore()));

  l = new QLabel(tr("Colore scelto:"), this);
  griglia->addWidget(l, 1, 7, 1, 3, Qt::AlignRight);

  anteprima = new Quadrattino(colore, this);
  griglia->addWidget(anteprima, 1, 10, 2, 2);

  q = new Quadrattino(global::ROSSO, this);
  griglia->addWidget(q, 2, 1, 1, 1);
  connect(q, SIGNAL(nuovoColore(QColor)), SLOT(nuovoColorePrivato(QColor)));

  q = new Quadrattino(global::GIALLO, this);
  griglia->addWidget(q, 2, 2, 1, 1);
  connect(q, SIGNAL(nuovoColore(QColor)), SLOT(nuovoColorePrivato(QColor)));

  q = new Quadrattino(global::VERDE, this);
  griglia->addWidget(q, 2, 3, 1, 1);
  connect(q, SIGNAL(nuovoColore(QColor)), SLOT(nuovoColorePrivato(QColor)));

  q = new Quadrattino(global::BLU, this);
  griglia->addWidget(q, 2, 4, 1, 1);
  connect(q, SIGNAL(nuovoColore(QColor)), SLOT(nuovoColorePrivato(QColor)));

  q = new Quadrattino(global::ARANCIO, this);
  griglia->addWidget(q, 2, 5, 1, 1);
  connect(q, SIGNAL(nuovoColore(QColor)), SLOT(nuovoColorePrivato(QColor)));

  q = new Quadrattino(global::GRIGIO, this);
  griglia->addWidget(q, 2, 6, 1, 1);
  connect(q, SIGNAL(nuovoColore(QColor)), SLOT(nuovoColorePrivato(QColor)));

  q = new Quadrattino(global::MARRONE, this);
  griglia->addWidget(q, 2, 7, 1, 1);
  connect(q, SIGNAL(nuovoColore(QColor)), SLOT(nuovoColorePrivato(QColor)));

  q = new Quadrattino(global::DARKGREEN, this);
  griglia->addWidget(q, 2, 8, 1, 1);
  connect(q, SIGNAL(nuovoColore(QColor)), SLOT(nuovoColorePrivato(QColor)));

  q = new Quadrattino(global::DARKRED, this);
  griglia->addWidget(q, 2, 9, 1, 1);
  connect(q, SIGNAL(nuovoColore(QColor)), SLOT(nuovoColorePrivato(QColor)));

  setLayout(griglia);
}

void PrendiColore::setColore(const QColor &c) {
  colore = c;
  anteprima->setColore(c);
}

void PrendiColore::nuovoColorePrivato(const QColor & c) {
  setColore(c);
  emit nuovoColore(c);
}

void PrendiColore::prendi_colore() {
  colore = QColorDialog::getColor(colore, this);
  anteprima->setColore(colore);
  emit nuovoColore(colore);
}

QColor PrendiColore::getColore() const {
  return colore;
}
