#include "quadrattino.h"

Quadrattino::Quadrattino(const QColor & c, QWidget *parent) :
    QWidget(parent) {
  colore = c;
  setMinimumSize(20, 20);
}

void Quadrattino::setColore(const QColor & c) {
  colore = c;
  update();
}

QColor Quadrattino::getColore() const {
  return colore;
}

void Quadrattino::mousePressEvent(QMouseEvent *event) {
  event->ignore();
  emit nuovoColore(colore);
}

void Quadrattino::paintEvent(QPaintEvent *event) {
  event->ignore();
  QPainter paint;
  paint.begin(this);
  paint.setPen(Qt::black);
  paint.setBrush(colore);
  paint.drawRect(0, 0, width() - 1, height() - 1);
  paint.end();
}
