#ifndef STORICO_H
#define STORICO_H

#include <QtCore>
#include <QtGui>
#include <QtSql>
#include "sql.h"
#include "widgetgrafico.h"
#include "ups.h"
#include "global.h"
#include "listawidgetadintervalli.h"
#include "intervallo.h"
#include "widgetgrafico.h"

class Storico : public QWidget {
  Q_OBJECT
  public:
    Storico(QList<Ups*> & list, QSqlDatabase *database, QWidget *parent = 0);

  private:
    QSqlDatabase *db;
    QList<Ups*> &upsList;
    QComboBox *ups;
    QComboBox *valoriups;
    QCalendarWidget *calendario;
    QComboBox *orario;
    WidgetGrafico *grafici[6];
    QLabel *data_grafici[6];

    void impostaColoreGrafici(int index);
    void copiaColoreGrafici(Ups *u, global::ValoriUps v);

  private slots:
    void calcolaUps(int index);
    void calcola();
    void oradopo();
    void oraprima();
    void cambiagrafici(int index);
    void salvaEaggiorna();

  public slots:
    void aggiornaListaUps();
};

#endif // STORICO_H
