#ifndef UPS_H
#define UPS_H

#include <QtCore>
#include <QtGui>
#include <QtSql>
#include "networkthread.h"
#include "sql.h"
#include "listawidgetadintervalli.h"

class Ups : public QObject {
    Q_OBJECT
  public:
    Ups(const SQL::UpsInfo & i, QObject *parent = 0);
    ~Ups();

    void setDB(QSqlDatabase *database);
    void setTabWidget(QTabWidget *tab);
    void setWidgetBarre(ListaWidgetAdIntervalli *w);
    void setWidgetGrafici(ListaWidgetAdIntervalli *w);
    void setMiniUpsWidget(QWidget *mini);
    void start();
    void stop();
    void waitStop();
    void salvaValoriInMemoria();
    SQL::UpsInfo getInfo() const;
    SQL::ValoriCostantiInfo getCostanti() const;
    void setInfo(const SQL::UpsInfo & i);
    ListaWidgetAdIntervalli * getWidgetBarre();
    ListaWidgetAdIntervalli * getWidgetGrafici();
    QWidget * getMiniUpsWidget();
    QTabWidget * getTabWidget();

  private:
    QVector<SQL::ValoriInfo> valori;
    NetworkThread net;
    QTabWidget *tabwidgetinterno;
    QWidget *miniUPS;
    ListaWidgetAdIntervalli *widgetbarre;
    ListaWidgetAdIntervalli *widgetgrafici;
    QSqlDatabase *db;
    SQL::UpsInfo ups;
    SQL::ValoriCostantiInfo costanti;
    QStringList events;
    bool primo;
    QDateTime ultimaDataOra;

  public slots:
    void askEvents();

  private slots:
    void getNewValue();
    void getNewConstant();
    void getNewEvents();

  signals:
    void nuovoValore(SQL::ValoriInfo v);
    void nuoveCostanti(SQL::ValoriCostantiInfo costanti);
    void nuovoGrezzo(QString s);
    void nuoviEventi(QStringList l);
};

#endif // UPS_H
