#include "widgetadintervalli.h"

WidgetAdIntervalli::WidgetAdIntervalli(QWidget *parent) :
    QWidget(parent) {
  sfumatura = true;
  bordo = true;
  colorebordo = Qt::black;
  coloretesto = Qt::black;
  colorevalori = Qt::blue;
}

const QString WidgetAdIntervalli::empty(tr("Vuoto"));

void WidgetAdIntervalli::setSfumatura(bool val) {
  sfumatura = val;
  repaint();
}

void WidgetAdIntervalli::setSfumaturaIntervalli(bool val) {
  for(QList<Intervallo>::iterator it = intervalli.begin(); it != intervalli.end(); it++)
    (*it).setSfumatura(val);
  repaint();
}

void WidgetAdIntervalli::aggiungiIntervallo(const Intervallo &i) {
  intervalli.push_back(i);
  qStableSort(intervalli.begin(), intervalli.end());
}

void WidgetAdIntervalli::aggiungiIntervallo(QColor c, double l, double h, int livello) {
  aggiungiIntervallo(Intervallo(c, l, h, livello));
}

void WidgetAdIntervalli::aggiungiIntervalli(const QList<Intervallo> & i) {
  for(int j = 0; j < i.size(); j++)
    aggiungiIntervallo(i[j]);
}

QList<Intervallo> WidgetAdIntervalli::getIntervalli() const {
  return intervalli;
}

void WidgetAdIntervalli::cancellaIntervalli(bool ridisegna) {
  intervalli.clear();
  if(ridisegna)
    repaint();
}

void WidgetAdIntervalli::setBordo(bool val) {
  bordo = val;
}

void WidgetAdIntervalli::setColoreBordo(QColor val) {
  colorebordo = val;
}

void WidgetAdIntervalli::setTesto(QString nome, QString u) {
  label = nome;
  udm = u;
  repaint();
}

void WidgetAdIntervalli::setColoreTesto(QColor c) {
  coloretesto = c;
}

void WidgetAdIntervalli::setColoreValori(QColor c) {
  colorevalori = c;
}

QColor WidgetAdIntervalli::getColoreValori() const {
  return colorevalori;
}

double WidgetAdIntervalli::trovaMin() const {
  double val = 0;
  if(intervalli.size() >= 1)
    val = intervalli[0].getSotto();
  for(int i = 1; i < intervalli.size(); i++)
    if(intervalli[i].getSotto() < val)
      val = intervalli[i].getSotto();
  return val;
}

double WidgetAdIntervalli::trovaMax() const {
  double val = 100;
  if(intervalli.size() >= 1)
    val = intervalli[0].getSopra();
  for(int i = 1; i < intervalli.size(); i++)
    if(intervalli[i].getSopra() > val)
      val = intervalli[i].getSopra();
  return val;
}

