#ifndef WIDGETADINTERVALLI_H
#define WIDGETADINTERVALLI_H

#include <QtCore>
#include <QtGui>
#include "intervallo.h"

class WidgetAdIntervalli : public QWidget {
    Q_OBJECT
  public:
    WidgetAdIntervalli(QWidget *parent = 0);

    void setSfumatura(bool val);
    void setSfumaturaIntervalli(bool val);
    QList<Intervallo> getIntervalli() const;
    void aggiungiIntervallo(const Intervallo & i);
    void aggiungiIntervalli(const QList<Intervallo> & i);
    void aggiungiIntervallo(QColor c, double l, double h, int livello = 0);
    void cancellaIntervalli(bool ridisegna = false);
    void setBordo(bool val);
    void setColoreBordo(QColor val);
    void setTesto(QString nome, QString u);
    void setColoreTesto(QColor c);
    void setColoreValori(QColor c);
    QColor getColoreValori() const;

  protected:
    virtual void paintEvent(QPaintEvent *event) = 0;
    double trovaMin() const;
    double trovaMax() const;

    static const QString empty;

    QList<Intervallo> intervalli;
    bool sfumatura;
    bool bordo;
    QColor colorebordo;
    QString label;
    QString udm;
    QColor coloretesto;
    QColor colorevalori;
};

#endif // WIDGETADINTERVALLI_H
