#ifndef WIDGETGRAFICO_H
#define WIDGETGRAFICO_H

#include <QtCore>
#include <QtGui>
#include "intervallo.h"
#include "widgetadintervalli.h"

class WidgetGrafico : public WidgetAdIntervalli {
  Q_OBJECT
  public:
    WidgetGrafico(QWidget *parent = 0);
    void pushValore(double valore, const QDateTime & orario, bool repainta = true, bool pulisci = true);
    void setIntervallo(int i);
    int getIntervallo() const;
    void setColoreGriglia(const QColor & c);
    void setColoreEvidenziato(const QColor & c);
    void setOrizzontali(int o);
    void clear(bool ridisegna = false);
    void ridisegna();
    void pulisciValori();

  protected:
    void mouseMoveEvent(QMouseEvent *evento);
    int xmouse, ymouse;

    struct Punti {
      bool operator==(const Punti & p) const;
      bool operator<(const Punti & p) const;
      double valore;
      QDateTime orario;
    };

    QVector<Punti> valori;
    int intervallo;
    QColor coloregriglia;
    QColor coloreevidenziato;
    int barreorizzontali;

    void paintEvent(QPaintEvent *event);
    void leaveEvent(QEvent *event);
};

#endif // WIDGETGRAFICO_H
